﻿; Generator Only My Railgun Process
; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)

Global MacroLoop.i, CodeLoop.i
Global NewList OutputCode.s()

Macro Buffer
  AddElement(Buffers()) : Buffers() =
EndMacro

Macro Out
  AddElement(OutputCode()) : OutputCode() =
EndMacro
  
Macro FNOPx32
  For MacroLoop=1 To 32
    Buffer "FNOP"
  Next
EndMacro

Macro OutputFNOPx32
  For MacroLoop=1 To 32
    Out "FNOP"
  Next
EndMacro

Global NewList Buffers.s()
Buffer "; Global OnlyMyRailGun.i"
For CodeLoop=1 To 32
  Buffer "PXOR mm5, mm5"
  Buffer "PXOR mm5, mm5"
  Buffer "PAND mm5, mm5"
  Buffer "PAND mm5, mm5"
Next
Buffer "; !MOVNTQ [v_OnlyMyRailGun], mm5"
Buffer "; !MOVQ mm5, [v_OnlyMyRailGun]"
OutputFNOPx32
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR Rax, Rax"
Buffer "XOR Rax, Rax"
Buffer "AND Rax, Rax"
Buffer "AND Rax, Rax"
Buffer "INC Rax"
Buffer "INC Rax"
Buffer "INC Rax"
Buffer "DEC Rax"
Buffer "DEC Rax"
Buffer "DEC Rax"
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "INC cl"
Buffer "MOVQ Rax, mm5"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
For CodeLoop=1 To 8
  Buffer "INC al"
  Buffer "SHL al, cl"
  Buffer "INC ah"
  Buffer "SHL ah, cl"
  Buffer "XCHG ah, al"
  Buffer "XCHG al, ah"
Next
Buffer "INC al"
Buffer "INC ah"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
Buffer "SHL Eax, cl" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Eax"
  Buffer "SHL Eax, cl"
Next
Buffer "INC Rax"
Buffer "SHL Rax, cl" ; FFFF FFFF
For CodeLoop=32 To 63
  Buffer "INC Rax"
  Buffer "SHL Rax, cl"
Next
Buffer "INC Rax" ; FFFF FFFF FFFF FFFF
Buffer "INC Rax" ; 0000
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
For CodeLoop=1 To 8
  Buffer "INC al"
  Buffer "SHL al, cl"
  Buffer "INC ah"
  Buffer "SHL ah, cl"
  Buffer "XCHG ah, al"
  Buffer "XCHG al, ah"
Next
Buffer "INC al"
Buffer "INC ah"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
Buffer "SHL Eax, cl" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Eax"
  Buffer "SHL Eax, cl"
Next
Buffer "INC Rax"
Buffer "SHL Rax, cl" ; FFFF FFFF
For CodeLoop=32 To 63
  Buffer "INC Rax"
  Buffer "SHL Rax, cl"
Next
Buffer "INC Rax" ; FFFF FFFF FFFF FFFF
Buffer "XOR Rcx, Rcx"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "a", "b")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "a", "d")
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR R8, R8"
Buffer "XOR R8, R8"
Buffer "AND R8, R8"
Buffer "AND R8, R8"
Buffer "INC R8"
Buffer "INC R8"
Buffer "INC R8"
Buffer "DEC R8"
Buffer "DEC R8"
Buffer "DEC R8"
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "INC cl"
Buffer "MOVQ R8, mm5"
Buffer "XCHG R8b, R8b"
For CodeLoop=1 To 8
  Buffer "INC R8b"
  Buffer "SHL R8b, cl"
Next
Buffer "INC R8b"
Buffer "SHL R8w, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC R8w"
  Buffer "SHL R8w, cl"
Next
Buffer "INC R8w"
Buffer "SHL R8d, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC R8d"
  Buffer "SHL R8d, cl"
Next
Buffer "INC R8d"
Buffer "SHL R8, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC R8"
  Buffer "SHL R8, cl"
Next
Buffer "INC R8"  ; FFFF FFFF FFFF FFFF
Buffer "INC R8" ; 0000
Buffer "XCHG R8b, R8b"
For CodeLoop=1 To 8
  Buffer "INC R8b"
  Buffer "SHL R8b, cl"
Next
Buffer "INC R8b"
Buffer "SHL R8w, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC R8w"
  Buffer "SHL R8w, cl"
Next
Buffer "INC R8w"
Buffer "SHL R8d, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC R8d"
  Buffer "SHL R8d, cl"
Next
Buffer "INC R8d"
Buffer "SHL R8, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC R8"
  Buffer "SHL R8, cl"
Next
Buffer "INC R8"  ; FFFF FFFF FFFF FFFF
Buffer "XOR Rcx, Rcx"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "9")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "10")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "11")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "12")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "13")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "14")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "15")
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "MOVQ Rcx, mm5"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
For CodeLoop=1 To 8
  Buffer "INC cl"
  Buffer "SHL cl, 1"
  Buffer "INC ch"
  Buffer "SHL ch, 1"
  Buffer "XCHG ch, cl"
  Buffer "XCHG cl, ch"
Next
Buffer "INC cl"
Buffer "INC ch"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
Buffer "SHL Ecx, 1" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Ecx"
  Buffer "SHL Ecx, 1"
Next
Buffer "INC Rcx"
Buffer "SHL Rcx, 1" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rcx"
  Buffer "SHL Rcx, 1"
Next
Buffer "INC Rcx"  ; FFFF FFFF FFFF FFFF
Buffer "INC Rcx"  ; 0000
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
For CodeLoop=1 To 8
  Buffer "INC cl"
  Buffer "SHL cl, 1"
  Buffer "INC ch"
  Buffer "SHL ch, 1"
  Buffer "XCHG ch, cl"
  Buffer "XCHG cl, ch"
Next
Buffer "INC cl"
Buffer "INC ch"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
Buffer "SHL Ecx, 1" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Ecx"
  Buffer "SHL Ecx, 1"
Next
Buffer "INC Rcx"
Buffer "SHL Rcx, 1" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rcx"
  Buffer "SHL Rcx, 1"
Next
Buffer "INC Rcx"  ; FFFF FFFF FFFF FFFF
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR Rbx, Rbx"
Buffer "XOR Rbx, Rbx"
Buffer "AND Rbx, Rbx"
Buffer "OR Rbx, Rbx"
Buffer "OR Rbx, Rbx"
Buffer "XOR Rbx, Rbx"
Buffer "XOR Rbx, Rbx"
Buffer "INC Rbx"
Buffer "INC Rbx"
Buffer "INC Rbx"
Buffer "DEC Rbx"
Buffer "DEC Rbx"
Buffer "DEC Rbx"
Buffer "XCHG spl, spl"
Buffer "MOVQ Rbx, mm5"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "b", "c")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "8")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "10")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "12")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "14")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "b", "a")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "b", "d")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "9")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "11")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "13")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "bx", "15")
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "MOV R8, Rsp"
Buffer "XOR Rsp, Rsp"
Buffer "XOR Rsp, Rsp"
Buffer "AND Rsp, Rsp"
Buffer "AND Rsp, Rsp"
Buffer "INC Rsp"
Buffer "INC Rsp"
Buffer "INC Rsp"
Buffer "DEC Rsp"
Buffer "DEC Rsp"
Buffer "DEC Rsp"
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "INC cl"
Buffer "MOVQ Rsp, mm5"
Buffer "XCHG spl, spl"
For CodeLoop=1 To 8
  Buffer "INC spl"
  Buffer "SHL spl, cl"
Next
Buffer "INC spl"
Buffer "SHL sp, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC sp"
  Buffer "SHL sp, cl"
Next
Buffer "INC sp"
Buffer "SHL Esp, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC Esp"
  Buffer "SHL Esp, cl"
Next
Buffer "INC Esp"
Buffer "SHL Rsp, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC Rsp"
  Buffer "SHL Rsp, cl"
Next
Buffer "INC Rsp" ; FFFF FFFF FFFF FFFF
Buffer "INC Rsp" ; 0000
Buffer "XCHG spl, spl"
For CodeLoop=1 To 8
  Buffer "INC spl"
  Buffer "SHL spl, cl"
Next
Buffer "INC spl"
Buffer "SHL sp, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC sp"
  Buffer "SHL sp, cl"
Next
Buffer "INC sp"
Buffer "SHL Esp, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC Esp"
  Buffer "SHL Esp, cl"
Next
Buffer "INC Esp"
Buffer "SHL Rsp, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC Rsp"
  Buffer "SHL Rsp, cl"
Next
Buffer "INC Rsp" ; FFFF FFFF FFFF FFFF
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rsp, Rsp"
Buffer "XOR Rsp, Rsp"
Buffer "AND Rsp, Rsp"
Buffer "OR Rsp, Rsp"
Buffer "OR Rsp, Rsp"
Buffer "XOR Rsp, Rsp"
Buffer "XOR Rsp, Rsp"
Buffer "INC Rsp"
Buffer "INC Rsp"
Buffer "INC Rsp"
Buffer "DEC Rsp"
Buffer "DEC Rsp"
Buffer "DEC Rsp"
Buffer "XCHG bpl, bpl"
Buffer "MOVQ Rsp, mm5"
Buffer "MOV Rsp, R8"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next

Global bufn.s
ForEach Buffers()
  bufn = Buffers()
  bufn = ReplaceString(bufn, "sp", "bp")
  bufn = ReplaceString(bufn, "Rbp, R8", "Rbp, R9")
  bufn = ReplaceString(bufn, "R8, Rbp", "R9, Rbp")
  bufn = ReplaceString(bufn, "XCHG bpl, bpl", "XCHG spl, spl")
  Out bufn
  OutputFNOPx32
Next
ForEach Buffers()
  bufn = Buffers()
  bufn = ReplaceString(bufn, "sp", "si")
  bufn = ReplaceString(bufn, "Rsi, R8", "Rsi, Rax")
  bufn = ReplaceString(bufn, "R8, Rsi", "Rax, Rsi")
  bufn = ReplaceString(bufn, "XCHG bpl, bpl", "XCHG spl, spl")
  Out bufn
  OutputFNOPx32
Next
ForEach Buffers()
  bufn = Buffers()
  bufn = ReplaceString(bufn, "sp", "di")
  bufn = ReplaceString(bufn, "Rdi, R8", "Rdi, Rbx")
  bufn = ReplaceString(bufn, "R8, Rdi", "Rbx, Rdi")
  bufn = ReplaceString(bufn, "XCHG bpl, bpl", "XCHG spl, spl")
  Out bufn
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR Rax, Rax"
Buffer "XOR Rax, Rax"
Buffer "AND Rax, Rax"
Buffer "AND Rax, Rax"
Buffer "INC Rax"
Buffer "INC Rax"
Buffer "INC Rax"
Buffer "DEC Rax"
Buffer "DEC Rax"
Buffer "DEC Rax"
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "INC cl"
Buffer "MOVQ Rax, mm5"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
For CodeLoop=1 To 8
  Buffer "INC al"
  Buffer "SHL al, cl"
  Buffer "INC ah"
  Buffer "SHL ah, cl"
  Buffer "XCHG ah, al"
  Buffer "XCHG al, ah"
Next
Buffer "INC al"
Buffer "INC ah"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
Buffer "SHL Eax, cl" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Eax"
  Buffer "SHL Eax, cl"
Next
Buffer "INC Rax"
Buffer "SHL Rax, cl" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rax"
  Buffer "SHL Rax, cl"
Next
Buffer "INC Rax" ; FFFF FFFF FFFF FFFF
Buffer "INC Rax" ; 0000
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
For CodeLoop=1 To 8
  Buffer "INC al"
  Buffer "SHL al, cl"
  Buffer "INC ah"
  Buffer "SHL ah, cl"
  Buffer "XCHG ah, al"
  Buffer "XCHG al, ah"
Next
Buffer "INC al"
Buffer "INC ah"
Buffer "XCHG ah, al"
Buffer "XCHG al, ah"
Buffer "SHL Eax, cl" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Eax"
  Buffer "SHL Eax, cl"
Next
Buffer "INC Rax"
Buffer "SHL Rax, cl" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rax"
  Buffer "SHL Rax, cl"
Next
Buffer "INC Rax" ; FFFF FFFF FFFF FFFF
Buffer "XOR Rcx, Rcx"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "a", "b")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "a", "d")
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR R8, R8"
Buffer "XOR R8, R8"
Buffer "AND R8, R8"
Buffer "AND R8, R8"
Buffer "INC R8"
Buffer "INC R8"
Buffer "INC R8"
Buffer "DEC R8"
Buffer "DEC R8"
Buffer "DEC R8"
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "INC cl"
Buffer "MOVQ R8, mm5"
Buffer "XCHG R8b, R8b"
For CodeLoop=1 To 8
  Buffer "INC R8b"
  Buffer "SHL R8b, cl"
Next
Buffer "INC R8b"
Buffer "SHL R8w, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC R8w"
  Buffer "SHL R8w, cl"
Next
Buffer "INC R8w"
Buffer "SHL R8d, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC R8d"
  Buffer "SHL R8d, cl"
Next
Buffer "INC R8d"
Buffer "SHL R8, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC R8"
  Buffer "SHL R8, cl"
Next
Buffer "INC R8" ; FFFF FFFF FFFF FFFF
Buffer "INC R8" ; 0000
Buffer "XCHG R8b, R8b"
For CodeLoop=1 To 8
  Buffer "INC R8b"
  Buffer "SHL R8b, cl"
Next
Buffer "INC R8b"
Buffer "SHL R8w, cl" ; FF
For CodeLoop=1 To 8
  Buffer "INC R8w"
  Buffer "SHL R8w, cl"
Next
Buffer "INC R8w"
Buffer "SHL R8d, cl" ; FFFF
For CodeLoop=1 To 16
  Buffer "INC R8d"
  Buffer "SHL R8d, cl"
Next
Buffer "INC R8d"
Buffer "SHL R8, cl" ; FFFF FFFF
For CodeLoop=1 To 32
  Buffer "INC R8"
  Buffer "SHL R8, cl"
Next
Buffer "INC R8" ; FFFF FFFF FFFF FFFF
Buffer "XOR Rcx, Rcx"
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "9")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "10")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "11")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "12")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "13")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "14")
  OutputFNOPx32
Next
ForEach Buffers()
  Out ReplaceString(Buffers(), "8", "15")
  OutputFNOPx32
Next

ClearList(Buffers())
Buffer "XOR Rcx, Rcx"
Buffer "XOR Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "AND Rcx, Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "INC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "DEC Rcx"
Buffer "MOVQ Rcx, mm5"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
For CodeLoop=1 To 8
  Buffer "INC cl"
  Buffer "SHL cl, 1"
  Buffer "INC ch"
  Buffer "SHL ch, 1"
  Buffer "XCHG ch, cl"
  Buffer "XCHG cl, ch"
Next
Buffer "INC cl"
Buffer "INC ch"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
Buffer "SHL Ecx, 1" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Ecx"
  Buffer "SHL Ecx, 1"
Next
Buffer "INC Rcx"
Buffer "SHL Rcx, 1" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rcx"
  Buffer "SHL Rcx, 1"
Next
Buffer "INC Rcx"  ; FFFF FFFF FFFF FFFF
Buffer "INC Rcx"  ; 0000
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
For CodeLoop=1 To 8
  Buffer "INC cl"
  Buffer "SHL cl, 1"
  Buffer "INC ch"
  Buffer "SHL ch, 1"
  Buffer "XCHG ch, cl"
  Buffer "XCHG cl, ch"
Next
Buffer "INC cl"
Buffer "INC ch"
Buffer "XCHG ch, cl"
Buffer "XCHG cl, ch"
Buffer "SHL Ecx, 1" ; FFFF
For CodeLoop=16 To 31
  Buffer "INC Ecx"
  Buffer "SHL Ecx, 1"
Next
Buffer "INC Rcx"
Buffer "SHL Rcx, 1" ; FFFF FFFF
For loop=32 To 63
  Buffer "INC Rcx"
  Buffer "SHL Rcx, 1"
Next
Buffer "INC Rcx"  ; FFFF FFFF FFFF FFFF
ForEach Buffers()
  Out Buffers()
  OutputFNOPx32
Next

ClearList(Buffers())
Out "EMMS"
OutputFNOPx32

Global fileno.i

fileno = CreateFile(#PB_Any, "WASAPI_OnlyMyRailgunProcess_Before.pbi")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_OnlyMyRailgunProcess_Before.pbi", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 512
    WriteStringN(fileno, "!FNOP", #PB_UTF8)    
  Next
  ForEach OutputCode()
    If Not Left(OutputCode(), 1)=";"
      WriteStringN(fileno, "!"+OutputCode(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

fileno = CreateFile(#PB_Any, "WASAPI_OnlyMyRailgunProcess_Before.txt")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_OnlyMyRailgunProcess_Before.txt", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 512
    WriteStringN(fileno, "FNOP", #PB_UTF8)    
  Next
  ForEach OutputCode()
    If Not Left(OutputCode(), 1)=";"
      WriteStringN(fileno, OutputCode(), #PB_UTF8)
    EndIf
  Next
  CloseFile(fileno)
EndIf

fileno = CreateFile(#PB_Any, "WASAPI_OnlyMyRailgunProcess_After.pbi")
If fileno
  WriteStringFormat(fileno, #PB_UTF8)
  WriteStringN(fileno, "; WASAPI_OnlyMyRailgunProcess_After.pbi", #PB_UTF8)
  WriteStringN(fileno, "; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)", #PB_UTF8)
  For I=1 To 512
    WriteStringN(fileno, "!FNOP", #PB_UTF8)    
  Next
  ForEach OutputCode()
    If FindString(OutputCode(), "OnlyMyRailGun")
      WriteStringN(fileno, Mid(OutputCode(), 3), #PB_UTF8)      
    Else
      If Not Left(OutputCode(), 1)=";"
        WriteStringN(fileno, "!"+OutputCode(), #PB_UTF8)
      EndIf
    EndIf
  Next
  CloseFile(fileno)
EndIf

End
