﻿; PureBasicForumTips_BuildExecutable.pb
; Copyright (c) 2017-2019, Hiroyuki Yokota (oryaaaaa)
SetPriorityClass_(GetCurrentProcess_(),#IDLE_PRIORITY_CLASS) 

#NBFILE = "PureBasicForumTips_WASAPI_player.pb"
#RCFILE = "PureBasicForumTips_WASAPI_player.rc"
#NBVER = "0.0.0.1"
#NBVER4 = "0,0,0,1"
#NBNAME = "PureBasicForumTips_WASAPI_player"
#NBEXE = "WASAPI_player.exe"
#NBCopyright = "Hiroyuki Yokota (oryaaaaa)"
#NBMAIL = "oryaaaaa@gmail.com"
file$=OpenFileRequester("PureBasic", "*.pb", "*.pb|"+#NBFILE, 0)
dir$ = GetPathPart(file$)
DeleteFile(dir$+"PureBasic.asm")

Select MessageRequester("CHECK", GetFilePart(file$), #PB_MessageRequester_YesNo)
  Case #PB_MessageRequester_No
    End
EndSelect

Global rc_fileno.i
rc_fileno = CreateFile(#PB_Any, dir$+#RCFILE, #PB_Unicode)
If rc_fileno
  WriteStringFormat(rc_fileno, #PB_Unicode)
  WriteStringN(rc_fileno, "", #PB_Unicode)
  WriteStringN(rc_fileno, "1 VERSIONINFO", #PB_Unicode)
  WriteStringN(rc_fileno, "FILEVERSION "+#NBVER4, #PB_Unicode)
  WriteStringN(rc_fileno, "PRODUCTVERSION "+#NBVER4, #PB_Unicode)
  WriteStringN(rc_fileno, "FILEOS 0x40004", #PB_Unicode)
  WriteStringN(rc_fileno, "FILETYPE 0x1", #PB_Unicode)
  WriteStringN(rc_fileno, "{", #PB_Unicode)
  WriteStringN(rc_fileno, "BLOCK "+Chr(34)+"StringFileInfo"+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, "{", #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+"BLOCK "+Chr(34)+"000004B0"+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+"{", #PB_Unicode)
  
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"CompanyName"+Chr(34)+", "+Chr(34)+#NBCopyright+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"ProductName"+Chr(34)+", "+Chr(34)+#NBNAME+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"ProductVersion"+Chr(34)+", "+Chr(34)+#NBVER+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"FileVersion"+Chr(34)+", "+Chr(34)+#NBVER+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"FileDescription"+Chr(34)+", "+Chr(34)+"Music Player for USB-DAC"+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"InternalName"+Chr(34)+", "+Chr(34)+#NBNAME+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"OriginalFilename"+Chr(34)+", "+Chr(34)+#NBEXE+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"LegalCopyright"+Chr(34)+", "+Chr(34)+#NBCopyright+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"LegalTrademarks"+Chr(34)+", "+Chr(34)+#NBCopyright+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"PrivateBuild"+Chr(34)+", "+Chr(34)+#NBFILE+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"SpecialBuild"+Chr(34)+", "+Chr(34)+"%date-% Windows 10"+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"Email"+Chr(34)+", "+Chr(34)+#NBMAIL+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+Chr(9)+"VALUE "+Chr(34)+"Comment"+Chr(34)+", "+Chr(34)+"free software."+Chr(34), #PB_Unicode)
  
  WriteStringN(rc_fileno, Chr(9)+"}", #PB_Unicode)
  WriteStringN(rc_fileno, "}", #PB_Unicode)
  WriteStringN(rc_fileno, "", #PB_Unicode)
  WriteStringN(rc_fileno, "BLOCK "+Chr(34)+"VarFileInfo"+Chr(34), #PB_Unicode)
  WriteStringN(rc_fileno, "{", #PB_Unicode)
  WriteStringN(rc_fileno, Chr(9)+"VALUE "+Chr(34)+"Translation"+Chr(34)+", 0x0000 0x04B0", #PB_Unicode)
  WriteStringN(rc_fileno, "}", #PB_Unicode)
  WriteStringN(rc_fileno, "}", #PB_Unicode)
  
  CloseFile(rc_fileno)
Else
  MessageRequester("ERROR RCFILE", "Don't create RCFILE")
EndIf

Global NewList Buffer.s()
ClearList(Buffer())

If file$ And FileSize(file$)>0
  Compiler = RunProgram(#PB_Compiler_Home+"\Compilers\pbcompiler", Chr(34)+file$+Chr(34)+" /MMX /UNICODE /commented", dir$, #PB_Program_Open | #PB_Program_Read)
  dir$+"PureBasic.asm"  
  ooos.i = 0
  Output$ = "" : Output_1$ = ""
  If Compiler
    While ProgramRunning(Compiler)
      If AvailableProgramOutput(Compiler)
        If ooos>50
          If ooos%2 = 1
            Output_1$ + ReadProgramString(Compiler) + Chr(13)
          Else
            Output_1$ + ReadProgramString(Compiler) + Space(2)
          EndIf
        Else
          If ooos%2 = 1
            Output$ + ReadProgramString(Compiler) + Chr(13)
          Else
            Output$ + ReadProgramString(Compiler) + Space(2)
          EndIf
        EndIf
        ooos + 1
      EndIf
    Wend
    Output$ + Chr(13) + Chr(13)
    Output_1$ + Chr(13) + Chr(13)
    Output$ + "Exitcode: " + Str(ProgramExitCode(Compiler))
    Output_1$ + "Exitcode: " + Str(ProgramExitCode(Compiler))    
    CloseProgram(Compiler) ; Close the connection to the program
  EndIf
Else
  MessageRequester("Error!", "There was an error creating the assembly code file.")
EndIf

; End  ;;; If you read PureBasic.asm file.

Delay(3000)
If ReadFile(2, dir$)
  While Eof(2)=0
    AddElement(Buffer())
    Buffer() = ReadString(2)
  Wend
  CloseFile(2)
EndIf

Global NewList InstructionName.s()
ForEach Buffer()
  If FindString(Buffer(), "extrn ")
    AddElement(InstructionName())
    InstructionName() = RemoveString(Buffer(), "extrn ")
  EndIf
  If ListSize(InstructionName())>1
    If Left(Buffer(), 1)=";"
      Break
    EndIf
  EndIf  
Next
ForEach Buffer()
  If Left(Buffer(), 10) = "_Procedure" And Right(Buffer(), 1)=":"
    AddElement(InstructionName())
    InstructionName() = RemoveString(Buffer(), ":")    
  EndIf
Next

Macro Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
  AddElement(Buffer()) : Buffer() = "NOP bx"
  AddElement(Buffer()) : Buffer() = "NOP Ebx"
  AddElement(Buffer()) : Buffer() = "NOP cx"
  AddElement(Buffer()) : Buffer() = "NOP Ecx"
  AddElement(Buffer()) : Buffer() = "NOP bp"
  AddElement(Buffer()) : Buffer() = "NOP Ebp"
  AddElement(Buffer()) : Buffer() = "NOP di"
  AddElement(Buffer()) : Buffer() = "NOP Edi"
  AddElement(Buffer()) : Buffer() = "NOP R8w"
  AddElement(Buffer()) : Buffer() = "NOP R8d"
  AddElement(Buffer()) : Buffer() = "NOP R10w"
  AddElement(Buffer()) : Buffer() = "NOP R10d"
  AddElement(Buffer()) : Buffer() = "NOP R12w"
  AddElement(Buffer()) : Buffer() = "NOP R12d"
  AddElement(Buffer()) : Buffer() = "NOP R14w"
  AddElement(Buffer()) : Buffer() = "NOP R14d"
  AddElement(Buffer()) : Buffer() = "NOP ax"
  AddElement(Buffer()) : Buffer() = "NOP Eax"
  AddElement(Buffer()) : Buffer() = "NOP dx"
  AddElement(Buffer()) : Buffer() = "NOP Edx"
  AddElement(Buffer()) : Buffer() = "NOP sp"
  AddElement(Buffer()) : Buffer() = "NOP Esp"
  AddElement(Buffer()) : Buffer() = "NOP si"
  AddElement(Buffer()) : Buffer() = "NOP Esi"
  AddElement(Buffer()) : Buffer() = "NOP R9w"
  AddElement(Buffer()) : Buffer() = "NOP R9d"
  AddElement(Buffer()) : Buffer() = "NOP R11w"
  AddElement(Buffer()) : Buffer() = "NOP R11d"
  AddElement(Buffer()) : Buffer() = "NOP R13w"
  AddElement(Buffer()) : Buffer() = "NOP R13d"
  AddElement(Buffer()) : Buffer() = "NOP R15w"
  AddElement(Buffer()) : Buffer() = "NOP R15d"
EndMacro

Macro Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
  AddElement(Buffer()) : Buffer() = "XCHG bh, bl"
  AddElement(Buffer()) : Buffer() = "XCHG bl, bh"
  AddElement(Buffer()) : Buffer() = "XCHG Ebx, Ebx"
  AddElement(Buffer()) : Buffer() = "XCHG ch, cl"
  AddElement(Buffer()) : Buffer() = "XCHG cl, ch"
  AddElement(Buffer()) : Buffer() = "XCHG Ecx, Ecx"
  AddElement(Buffer()) : Buffer() = "XCHG bp, bp"
  AddElement(Buffer()) : Buffer() = "XCHG Ebp, Ebp"
  AddElement(Buffer()) : Buffer() = "XCHG di, di"
  AddElement(Buffer()) : Buffer() = "XCHG Edi, Edi"
  AddElement(Buffer()) : Buffer() = "XCHG R8w, R8w"
  AddElement(Buffer()) : Buffer() = "XCHG R8d, R8d"
  AddElement(Buffer()) : Buffer() = "XCHG R10w, R10w"
  AddElement(Buffer()) : Buffer() = "XCHG R10d, R10d"
  AddElement(Buffer()) : Buffer() = "XCHG R12w, R12w"
  AddElement(Buffer()) : Buffer() = "XCHG R12d, R12d"
  AddElement(Buffer()) : Buffer() = "XCHG R14w, R14w"
  AddElement(Buffer()) : Buffer() = "XCHG R14d, R14d"
  AddElement(Buffer()) : Buffer() = "XCHG ah, al"
  AddElement(Buffer()) : Buffer() = "XCHG al, ah"
  AddElement(Buffer()) : Buffer() = "XCHG Eax, Eax"
  AddElement(Buffer()) : Buffer() = "XCHG dh, dl"
  AddElement(Buffer()) : Buffer() = "XCHG dl, dh"
  AddElement(Buffer()) : Buffer() = "XCHG Edx, Edx"
  AddElement(Buffer()) : Buffer() = "XCHG sp, sp"
  AddElement(Buffer()) : Buffer() = "XCHG Esp, Esp"
  AddElement(Buffer()) : Buffer() = "XCHG si, si"
  AddElement(Buffer()) : Buffer() = "XCHG Esi, Esi"
  AddElement(Buffer()) : Buffer() = "XCHG R9w, R9w"
  AddElement(Buffer()) : Buffer() = "XCHG R9d, R9d"
  AddElement(Buffer()) : Buffer() = "XCHG R11w, R11w"
  AddElement(Buffer()) : Buffer() = "XCHG R11d, R11d"
  AddElement(Buffer()) : Buffer() = "XCHG R13w, R13w"
  AddElement(Buffer()) : Buffer() = "XCHG R13d, R13d"
  AddElement(Buffer()) : Buffer() = "XCHG R15w, R15w"
  AddElement(Buffer()) : Buffer() = "XCHG R15d, R15d"
EndMacro

ForEach Buffer()
  If Left(Buffer(), 5) = "  RET"
    PreviousElement(Buffer())
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    NextElement(Buffer())
    AddElement(Buffer()) : Buffer() = "JMP PureBasicStart"
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
  EndIf
Next

ForEach Buffer()
  If FindString(Buffer(), "; Procedure")
    If Not FindString(Buffer(), "; ProcedureReturn")
      Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
      Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    EndIf
  EndIf  
Next

Global CodeLoop.i, ReadStr.s

ForEach Buffer()
  If FindString(Buffer(), "PureBasicStart:")
    AddElement(Buffer()) : Buffer() = "WAIT"
    AddElement(Buffer()) : Buffer() = "WAIT"
    For CodeLoop=1 To 512
      AddElement(Buffer()) : Buffer() = "FNOP"
    Next
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    AddElement(Buffer()) : Buffer() = "JMP GateOfBabylon"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP GateOfBabylon"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP PureBasicStart"
    ForEach InstructionName()
      AddElement(Buffer()) : Buffer() = "FNOP"
      AddElement(Buffer()) : Buffer() = "FNOP"
      AddElement(Buffer()) : Buffer() = "JMP "+InstructionName()
    Next
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_END_Finish"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WASAPI_Proc_LOOP_Start"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WASAPI_Proc_LOOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiPorc_Process_A"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiPorc_Process_B"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_EndIf47"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_EndIf48"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_EndIf49"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP FillMemoryNatural_Start"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_NOP_XCHG_A"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_NOP_XCHG_B"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_NOP_XCHG_C"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP WasapiProc_NOP_XCHG_D"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "JMP MainThread_Repeat_Start"
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    For CodeLoop=1 To 66
      AddElement(Buffer()) : Buffer() = "JMP GateOfBabylon_WasapiProc_"+Str(CodeLoop)
      AddElement(Buffer()) : Buffer() = "FNOP"
      AddElement(Buffer()) : Buffer() = "FNOP"
    Next
    AddElement(Buffer()) : Buffer() = "GateOfBabylon:"
    For CodeLoop=1 To 2*1024*1024
      AddElement(Buffer()) : Buffer() = "FNOP"      
    Next
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    fileno = ReadFile(#PB_Any, "WASAPI_OnlyMyRailgunProcess_Before.txt", #PB_UTF8)
    If fileno
      ReadStringFormat(fileno)
      While Eof(fileno) = 0
        ReadStr = ReadString(fileno, #PB_UTF8)
        If Not Left(ReadStr, 1)=";"
          AddElement(Buffer()) : Buffer() = ReadStr
        EndIf
      Wend
      CloseFile(fileno)
    Else
      MessageRequester("FILE","ERROR WASAPI_OnlyMyRailgunProcess_Before.txt")
    EndIf
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    fileno = ReadFile(#PB_Any, "WASAPI_Stabilizer_3_MMX.txt", #PB_UTF8)
    If fileno
      ReadStringFormat(fileno)
      While Eof(fileno) = 0
        ReadStr = ReadString(fileno, #PB_UTF8)
        If Not Left(ReadStr, 1)=";"
          AddElement(Buffer()) : Buffer() = ReadStr
        EndIf
      Wend
      CloseFile(fileno)
    Else
      MessageRequester("FILE","ERROR WASAPI_Stabilizer_3_MMX.txt")
    EndIf
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    fileno = ReadFile(#PB_Any, "WASAPI_OnlyMyRailgunProcess_Before.txt", #PB_UTF8)
    If fileno
      ReadStringFormat(fileno)
      While Eof(fileno) = 0
        ReadStr = ReadString(fileno, #PB_UTF8)
        If Not Left(ReadStr, 1)=";"
          AddElement(Buffer()) : Buffer() = ReadStr
        EndIf
      Wend
      CloseFile(fileno)
    Else
      MessageRequester("FILE","ERROR WASAPI_OnlyMyRailgunProcess_Before.txt")
    EndIf
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    fileno = ReadFile(#PB_Any, "WASAPI_Stabilizer_3_MMX.txt", #PB_UTF8)
    If fileno
      ReadStringFormat(fileno)
      While Eof(fileno) = 0
        ReadStr = ReadString(fileno, #PB_UTF8)
        If Not Left(ReadStr, 1)=";"
          AddElement(Buffer()) : Buffer() = ReadStr
        EndIf
      Wend
      CloseFile(fileno)
    Else
      MessageRequester("FILE","ERROR WASAPI_Stabilizer_3_MMX.txt")
    EndIf
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Nop_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    Xchg_bxEbxEcxR8d10d_axEaxEdxR9dR11d
    AddElement(Buffer()) : Buffer() = "XCHG spl, bpl"
    AddElement(Buffer()) : Buffer() = "XCHG Rsp, Rsp"
    AddElement(Buffer()) : Buffer() = "XCHG Rbp, Rbp"
    AddElement(Buffer()) : Buffer() = "XCHG bpl, spl"
    AddElement(Buffer()) : Buffer() = "XCHG Rsp, Rsp"
    AddElement(Buffer()) : Buffer() = "XCHG Rbp, Rbp"
    AddElement(Buffer()) : Buffer() = "XCHG spl, bpl"
    AddElement(Buffer()) : Buffer() = "XCHG Rsp, Rsp"
    AddElement(Buffer()) : Buffer() = "XCHG Rbp, Rbp"
    AddElement(Buffer()) : Buffer() = "XCHG bpl, spl"
    AddElement(Buffer()) : Buffer() = "AddFNOP32_S_PureBasicStart"
    AddFNOP_S_PureBasicStart_Loop:
    NextElement(Buffer())
    If Left(Buffer(), 18) <> "PureBasicStartEND:"
      Goto AddFNOP_S_PureBasicStart_Loop
    EndIf
    Buffer() = "AddFNOP32_E_PureBasicStart"
    Break
  EndIf
Next


Global NS_Find_1.i, NS_Find_2.i, NS_Find_3.i, NS_Find_4.i, NS_Find_5.i
ForEach Buffer()
  NS_Find_1 = FindString(Buffer(), "MOV ")
  If NS_Find_1
    NS_Find_2 = FindString(Buffer(), "[PB_")
    NS_Find_3 = FindString(Buffer(), ",")
    If NS_Find_2>0 And NS_Find_3>0 And NS_Find_2<NS_Find_3
      Buffer() = ReplaceString(Buffer(), "MOV", "MOVNTI")
    EndIf 
  EndIf
Next


Global Sub_pos.i, Sub_max.i
ForEach Buffer()
  If FindString(Buffer(), " SUB    rsp,") And Val(StringField(Buffer(), 2, ","))>0
    Sub_pos = 0 : Sub_max =0
    Sub_max = Val(StringField(Buffer(), 2, ","))
    Buffer() = "FNOP"
    For Sub_pos=1 To Sub_max
      AddElement(Buffer()) : Buffer() = "DEC rsp" ; Sub
    Next
    AddElement(Buffer()) : Buffer() = "FNOP"  
  EndIf
Next
Global Add_pos.i, Add_max.i
ForEach Buffer()
  If FindString(Buffer(), " ADD    rsp,") And Val(StringField(Buffer(), 2, ","))>0
    Add_max = 0 : Add_pos = 0
    Add_max = Val(StringField(Buffer(), 2, ","))
    Buffer() = "FNOP"
    For Add_pos=1 To Add_max
      AddElement(Buffer()) : Buffer() = "INC rsp" ; Add
    Next
    AddElement(Buffer()) : Buffer() = "FNOP"  
  EndIf
Next
ForEach Buffer()
  If FindString(Buffer(), "PUSH ")
    PreviousElement(Buffer())
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    NextElement(Buffer())
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
  EndIf
Next
ForEach Buffer()
  If FindString(Buffer(), "POP ")
    PreviousElement(Buffer())
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
    NextElement(Buffer())
    AddElement(Buffer()) : Buffer() = "FNOP"
    AddElement(Buffer()) : Buffer() = "FNOP"
  EndIf
Next

ForEach Buffer()
  NS_Find_1 = FindString(Buffer(), "MOV ")
  If NS_Find_1
    NS_Find_2 = FindString(Buffer(), "[")
    NS_Find_3 = FindString(Buffer(), ",")
    NS_Find_5 = FindString(LCase(Buffer()), "qword")
    If Not NS_Find_5
      NS_Find_5 = FindString(LCase(Buffer()), "dword")
    EndIf
    NS_Find_4 = FindString(LCase(Buffer()), "a", NS_Find_3)
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "b", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "c", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "d", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "p", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "i", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r8", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r9", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r10", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r11", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r12", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r13", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r14", NS_Find_3)
    EndIf
    If Not NS_Find_4
      NS_Find_4 = FindString(LCase(Buffer()), "r15", NS_Find_3)
    EndIf
    If NS_Find_2>0 And NS_Find_3>0 And NS_Find_2<NS_Find_3 And NS_Find_5>0 And NS_Find_4>0
      Buffer() = ReplaceString(Buffer(), "MOV", "MOVNTI")
    EndIf 
  EndIf
Next

;+++ Remove FNOP lines
ForEach Buffer()
  If Left(Buffer(),10) ="AddFNOP_S_"
    AddFNOP_loop:
    NextElement(Buffer())
    If Left(Buffer(), 4) = "FNOP"
      DeleteElement(Buffer())
      Goto AddFNOP_loop
    EndIf
    If Left(Buffer(),10) <> "AddFNOP_E_"
      Goto AddFNOP_loop
    EndIf
  EndIf
Next
;+++ Add FNOPx16
ForEach Buffer()
  If Left(Buffer(),10) ="AddFNOP_S_"
    DeleteElement(Buffer())
    AddFNOP_loop2:
    NextElement(Buffer())
    If FindString(Buffer(), ":")>0 Or Left(Buffer(), 1)=";"
      If Left(Buffer(), 10) <> "AddFNOP_E_"
        Goto AddFNOP_loop2
      EndIf
    EndIf
    If Left(Buffer(),10) <> "AddFNOP_E_"
      For CodeLoop=1 To 16
        AddElement(Buffer()) : Buffer() = "FNOP"
      Next
      Goto AddFNOP_loop2
    EndIf
    DeleteElement(Buffer())
    NextElement(Buffer())
 EndIf
Next
;+++ Add FNOPx32
ForEach Buffer()
  If Left(Buffer(),17) ="WASAPI_Proc_LOOP:"
    For CodeLoop=1 To 32
      AddElement(Buffer()) : Buffer() = "FNOP"
    Next
  EndIf  
Next

;+++ Add FNOPx32
ForEach Buffer()
  If Left(Buffer(),12) ="AddFNOP32_S_"
    DeleteElement(Buffer())
    AddFNOP_loop3:
    NextElement(Buffer())
    If FindString(Buffer(), ":")>0 Or Left(Buffer(), 1)=";"
      If Left(Buffer(), 12) <> "AddFNOP32_E_"
        Goto AddFNOP_loop3
      EndIf
    EndIf
    If Left(Buffer(),12) <> "AddFNOP32_E_"
      For CodeLoop=1 To 32
        AddElement(Buffer()) : Buffer() = "FNOP"
      Next
      Goto AddFNOP_loop3
    EndIf
    DeleteElement(Buffer())
    NextElement(Buffer())
 EndIf
Next

fileno = CreateFile(#PB_Any, dir$)
ForEach Buffer()
  WriteStringN(fileno, Buffer())
Next
FlushFileBuffers(fileno)
CloseFile(fileno)

ClearList(Buffer())
file$ = dir$
dir$ = GetPathPart(file$)

Delay(3000)

Compiler = RunProgram(#PB_Compiler_Home+"\Compilers\pbcompiler", Chr(34)+file$+Chr(34)+" /MMX /UNICODE /REASM /RESOURCE "+Chr(34)+#RCFILE+Chr(34)+" /EXE "+Chr(34)+#NBEXE+Chr(34), dir$, #PB_Program_Open | #PB_Program_Read)
If Compiler
  While ProgramRunning(Compiler)
    If AvailableProgramOutput(Compiler)
      Output2$ + ReadProgramString(Compiler) + Chr(13)
    EndIf
  Wend
  Output2$ + Chr(13) + Chr(13)
  Output2$ + "Exitcode: " + Str(ProgramExitCode(Compiler))
  CloseProgram(Compiler) ; Close the connection to the program
EndIf

MessageRequester("Output", Output$)
MessageRequester("Output2", Output_1$)
MessageRequester("Output", Output2$) 

End
